import React, { useEffect, useState } from "react";
import { Form, Input, Select,DatePicker ,Switch} from 'antd';
import useMount from '../useMount/index.js';
import moment from 'moment';
const {RangePicker } = DatePicker;
function uuid() {
    var s:any = [];
    var hexDigits = "0123456789abcdef";
    for (var i = 0; i < 36; i++) {
        s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
    }
    s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
    s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
    s[8] = s[13] = s[18] = s[23] = "-";
  
    var uuid = s.join("");
    return uuid;
}
const App = (props: any = {}) => {
    let { type = "input", itemConfig = {}, dataIndex = "",is_number=false } = props;
    let [formRef] = Form.useForm();
    // props.menRefs.push(formRef)
    let [val,setVal] = useState(props.val);
    // 是否禁止编辑
    let [forbidEdit, setForbidEdit] = useState(true);
    useMount(() => {
        let uid = uuid();
        props.setInstance && props.setInstance(uid,formRef);
        return ()=>{
            props.setAction && props.setAction(uid,formRef,true);
        }
    })
    // 父组件值更新以后更新子组件的值
    useEffect(() => {
        if (type === "rangePicker"){

            // setVal(props.val);
            let newVal = props.val;
            if(!newVal){
                newVal = "";
            }
            let time  = newVal.split("至");
            // initVal  = [moment(time[0]),moment(time[1])]
            if(time[1]){
                newVal = [moment(time[0]),moment(time[1])]
            }else{
                newVal =  ""
            }
            formRef.setFieldsValue({ [dataIndex]: newVal })
        }else{
            let preValue = props.val;
            if(typeof preValue ==="undefined"){
                preValue = "";
            }
            
            formRef.setFieldsValue({ [dataIndex]: preValue })
        }
    }, [props.val])
    // 初始值  
    
    // 获取焦点事件 编辑前事件
    const onFocus = (current: any, key: string, record: any) => {
        props.beforeChange && setForbidEdit(props.beforeChange(current, key, record))
    }
    // 通用值改变时的事件
    const onChange = (value: any) => {
        // debugger;
        if (type === "rangePicker") {
            let time = value[0].format('YYYY-MM-DD')+"至"+value[1].format('YYYY-MM-DD')
            // 是否不允许编辑
            if (!forbidEdit) {
                // setVal(val || "")
                // 转换时间格式
                if(!val){
                    val = "";
                }
                time  = val.split("至");
                 
                // initVal  = [moment(time[0]),moment(time[1])]
                if(time[1]){
                    formRef.setFieldsValue({ [dataIndex]: [moment(time[0]),moment(time[1])] })
                }else{
                    formRef.setFieldsValue({ [dataIndex]: "" })
                }
                return;
            }

            // setVal(time);
            props.setChange(dataIndex, props.index, time, props.record, formRef);

        }//通用值更新  input  select
        else {
            // 是否不允许编辑
            if (!forbidEdit) {
                // setVal(val || "")
                formRef.setFieldsValue({ [dataIndex]: val })
                return;
            }
            if(is_number){
                if(value[0]=="0"&&typeof value[1] !=="undefined"&&value[1]!="."){
                    value = value.slice(1);
                    formRef.setFieldsValue({ [dataIndex]: value })
                }
                if(value[0]=="-"){
                    value = value.slice(1);
                    formRef.setFieldsValue({ [dataIndex]: value })
                }
                let number_arr = (value+"").split(".");
                if(number_arr.length===2){
                    number_arr[1] = ("9."+number_arr[1]).replace(/^(\-)*(\d+)\.(\d\d).*$/, '$1$2.$3').split("9.")[1];

                    value = number_arr.join(".");
                    formRef.setFieldsValue({ [dataIndex]: value })
                }
                
            }
            // setVal(value);
            props.setChange(dataIndex, props.index,value, props.record, formRef);

        }
    }
    let comm: any = {
        "input": {
            render: () => {
                return <Form
                    form={formRef}
                    // initialValues={{ [dataIndex]: val }}
                    onValuesChange={(...ars) => {
                        onChange(ars[0][dataIndex])
                    }}
                >
                    <Form.Item
                        name={dataIndex}
                        {...itemConfig}
                    >
                        <Input 
                         value={val}
                         onFocus={() => {
                            onFocus(dataIndex, val, props.record);
                        }} />
                    </Form.Item>
                </Form>
            }
        },
        "select": {
            render: () => {
                return <Form
                    form={formRef}
                    initialValues={{ [dataIndex]: val }}
                    onValuesChange={(...ars) => {
                        onChange(ars[0][dataIndex])

                    }}
                >
                    <Form.Item
                        name={dataIndex}
                        {...itemConfig}
                    >
                        <Select
                            
                            options={props.options || []}
                            onFocus={() => {
                                onFocus(dataIndex, val, props.record);
                            }} />
                    </Form.Item>
                </Form>
            }
        },
        "textArea": {
            render: () => {
                return <Form
                    form={formRef}
                    initialValues={{ [dataIndex]: val }}
                    onValuesChange={(...ars) => {
                        onChange(ars[0][dataIndex])

                    }}
                >
                    <Form.Item
                        name={dataIndex}
                        {...itemConfig}
                    >
                        <Input.TextArea 
                       
                         onFocus={() => {
                            onFocus(dataIndex, val, props.record);
                        }} />
                    </Form.Item>
                </Form>
            }
        },
        "rangePicker": {
            render: () => {
                let newVal = val;
                if(!newVal){
                    newVal = "";
                }
                let time  = newVal.split("至");
                // initVal  = [moment(time[0]),moment(time[1])]
                if(time[1]){
                    newVal = [moment(time[0]),moment(time[1])]
                }else{
                    newVal =  ""
                }
                let timeNum = {
                    view:false,
                    num:0
                };
                return <Form
                    form={formRef}
                    initialValues={{ [dataIndex]: newVal }}
                    onValuesChange={(...ars) => {
                        onChange(ars[0][dataIndex])

                    }}
                >
                    <Form.Item
                        name={dataIndex}
                        // initialValue={newVal}
                        {...itemConfig}
                    >
                        <RangePicker
                             onFocus={() => {
                                onFocus(dataIndex, val, props.record);
                            }}
                           
                            dateRender={(...ars: any) => {
                                if (ars[0].date() === 1 && timeNum.view === false) {
                                    timeNum = {
                                        view: true,
                                        num: 1
                                    }
                                } else if (ars[0].date() === 1 && timeNum.view === true) {
                                    timeNum = {
                                        view: false,
                                        num: 0
                                    };
                                }
                                if (timeNum.num === 1 && timeNum.view) {
                                    return <div className="ant-picker-cell-inner" >
                                        {ars[0].date()}
                                    </div>;
                                } else {
                                    // return <div className="ant-picker-cell-inner" ></div>
                                    return null

                                }

                            }}
                            // ref={inputRef} 
                            showNow={true} 
                            // onChange={save} 
                            // onBlur={save} 
                            />
                        {/* <Input.TextArea onFocus={() => {
                            onFocus(dataIndex, val, props.record);
                        }} /> */}
                    </Form.Item>
                </Form>
            }
        },
        "switch": {
            render: () => {
                return <Form
                    form={formRef}
                    initialValues={{ [dataIndex]: val }}
                    onValuesChange={(...ars) => {
                        onChange(ars[0][dataIndex])
                    }}
                >
                    <Form.Item
                        name={dataIndex}
                        // initialValue={newVal}
                        valuePropName="checked"
                        {...itemConfig}
                    >
                        <Switch />
                    </Form.Item>
                </Form>
            }
        },
        "defalutRender":{
            render:()=>{
                return "当前类型不存在或者正在开发中！Mendege"
            }
        }
    }

    return comm[type]?comm[type].render():comm["defalutRender"].render();


}

export default App;