import { Tree,Input} from 'antd';
import { DownOutlined } from '@ant-design/icons';
import { useEffect, useState } from 'react';
import _ from "lodash";
import "./index.less"
const { TreeNode } = Tree;
const { Search } = Input;
// 实例存储
let menAction = {};

// 设置树数据
const menSetTreeData = (id,data,callback)=>{
  // 需要校验数据合法性
  if (menAction[id] && menAction[id].setData) {
       menAction[id].setData(data, callback);
} else {
    console.warn("menSetTreeData 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
}
}
// 获取当前选中的数据
const menGetTreeSelected = (id)=>{
  if (menAction[id] && menAction[id].setData) {
    return menAction[id].getSelect();
  } else {
  console.warn(`menGetTreeSelected 当前设置时机不对 实例不存在 或者 传入${id}错误 !Mendege`)
  }
}
// 获取当前树数据

const menGetTreeData = (id)=>{
  if (menAction[id] && menAction[id].setData) {
    return menAction[id].getData();
  } else {
  console.warn(`menGetTreeData 当前设置时机不对 实例不存在 或者 传入${id}错误 !Mendege`)
  }
}












// 展平数据 
const flattenData = (data, newData = new Map(), pid) => {
  if (!Array.isArray(data)) {
    return newData;
  }
  if (!data.length) {
    return newData;
  }
  data.forEach((i) => {
    let { children, ...others } = i;
    others.pid = pid || "root"
    others.text = pid || "root"
    newData.set(others.key, others);
    if (Array.isArray(children)) {
      flattenData(children, newData, others.key)
    }
  })
  return newData;
}
// 生成树结构
const createTreeData = (data, searValue,newData = []) => {
  let _data_his = _.cloneDeep(data);
  let _data = new Map();
  if(searValue){
    _data_his.forEach((i)=>{
        if(typeof i.title === "string"){
            if(i.title.indexOf(searValue)>-1){
              _data.set(i.key,i)
            }
        }
    })
  }
  _data.forEach((i, k) => {
    // 查询当前元素的pKey 如果 为root 或者 空 那么在第一层级 
    // 生成一个待分配的元素 map 
    if (i.pid === "root" || !i.pid) {
      newData.push(i);
    } else {
      if (_data.has(i.pid)) {
        (_data.get(i.pid).children || (_data.get(i.pid).children = [])).push(i);
      } else {
        newData.push(i);
      }
    }

  });

  return newData;
}
const TestTreeData = [
  {
    title: <span
      onDoubleClick={(e, ...ars) => {
        e.stopPropagation()
      }}
    >'parent 1'</span>,
    key: '0-0',
    children: [
      {
        title: 'parent 1-0',
        key: '0-0-0',
        values: {
          status: "这是什么"
        },
        children: [
          {
            title: 'leaf',
            key: '0-0-0-0',
          },
          {
            title: 'leaf',
            key: '0-0-0-1',
          },
          {
            title: 'leaf',
            key: '0-0-0-2',
          },
        ],
      },
      {
        title: 'parent 1-1',
        key: '0-0-1',
        children: [
          {
            title: 'leaf',
            key: '0-0-1-0',
          },
        ],
      },
      {
        title: 'parent 1-2',
        key: '0-0-2',
        children: [
          {
            title: 'leaf',
            key: '0-0-2-0',
          },
          {
            title: 'leaf',
            key: '0-0-2-1',
          },
        ],
      },
    ],
  },
];
// 默认配置
let initConfig  = {
  checkStrictly:true,
  height : 300,
  showLine : true,
  virtual:false,
};
// 创建组件  radio 是否单选  默认单选 true  单选情况下 不允许出现复选框 同样 非单选[false]情况下 树点击不可选中数据
/*
  defaultExpandedKeys:true,//是否默认展开根元素
*/ 
//陆续会增加  交互事件  需要使用的话 传入 men + antd 事件 首字母大写  主要用于二次扩展
const MenTree = (props = {}) => {
  let { id = "", config = {} } = props;
  let { 
    treeConfig = {}, 
  defaultExpandedKeys = true,
   radio = true,
   } = config;
  if (!menAction[id]) {
    menAction[id] = {}
  }
  treeConfig = Object.assign(initConfig,treeConfig);
  // 组件被销毁时必须销毁内存
  useEffect(() => {
    return () => {
      delete menAction[id]
    };
  }, [])
  menAction[id].config = config;  
  // 是否单选  默认单选 单选情况下 不允许出现复选框 同样 非单选情况下 树点击不可选中数据
  // 优先级最高  会产生覆盖动作
  if (radio) {
    // 支持选中 selectable
    treeConfig.selectable = true;
    // 不允许出现复选框 checkable
    treeConfig.checkable = false;
    // 只允许 单选 multiple
    treeConfig.multiple = false;
  } else {
    // 不支持选中 selectable
    treeConfig.selectable = false;
    // 一定出现复选框 checkable
    treeConfig.checkable = true;
    // 必须多选 multiple
    treeConfig.multiple = true;
  }
  // 树数据
  let [treeData, setTreeData] = useState(config.data||[]);
  let [searTreeData,setSearTreeData] = useState([]);
  let [searValue,setSearValue] = useState("");
  // 选中数据  复选框
  let [checkedKeys, setCheckedKeys] = useState(config.selectNode||[]);
  // 选中 数据  点击 通常只用于 单选
  let [selectedKeys, setSelectedKeys] = useState(config.selectNode||[]);
  let selectedKeysObj = {};
  // 展开节点
  let [expandedKeys, setExpandedKeys] = useState([]);
  // 默认展开 树节点
  let defaultExpandedKeysObj = {};
  // 展平数据 展平一次  如果是异步 每次异步以后 需要将新的数据载入该数据
  if (!menAction[id].dataMap && treeData.length) {
    menAction[id].dataMap = flattenData(treeData);
  }
  // 处理默认展开的节点  defaultExpandedKeys 
  // 默认展开当前数据的第一个 如果 存在  该参数  或者为false 不做任何操作
  // 或者treeConfig.defaultExpandedKeys 存在 会取 该值作为默认展开参数  
  if (defaultExpandedKeys && !treeConfig.defaultExpandedKeys && treeData.length > 0) {
    defaultExpandedKeysObj = {
      defaultExpandedKeys: [treeData[0].key]
    }
  }
  //  单机选中 只有在 确定 有 selectedKeys 数据以后 才会收回控制权
  if (selectedKeys.length) {
    selectedKeysObj = {
      selectedKeys: selectedKeys
    }
  }
  //  展开树节点 只有在 expandedKeys 存在的情况下  才会回收 控制权
  let expandedKeysObj = {};
  if (expandedKeys.length) {
    expandedKeysObj = {
      expandedKeys: expandedKeys
    }
  }
  // 只有确定出现复选框 并且 选中数据不为空    才传入相应的复选框组件并且回收数据 进行控制
  let checkedKeysObj = {};
  if (treeConfig.checkable && checkedKeys.length) {
    checkedKeysObj.checkedKeys = checkedKeys;

  }
  // 挂载 外抛方法
  menAction[id].setData = (data) => {
    // 不去做分辨 只根据是否单选 来实现
    setTreeData(data)
    // if (radio) {
    //   setSelectedKeys(selectedKeys);
    // } else {
    //   setCheckedKeys(checkedKeys)
    // }
  }
  menAction[id].getData = () => {
    return treeData;
  }
  menAction[id].getSelect = ()=>{
    // {value:i.key||i.value||"",label:i.title||i.label||"",pid:i.pid}
    let sdata = null;
      if(radio){
        sdata =  selectedKeys.map((i)=>({
          value:i,
          label:menAction[id].dataMap.get(i).title,
          pid:menAction[id].dataMap.get(i).pid||pid
        }));
      }else{
        sdata = checkedKeys.map((i)=>({
          value:i,
          label:menAction[id].dataMap.get(i).title,
          pid:menAction[id].dataMap.get(i).pid||pid
        }));
      }
    return sdata;
  }
  // 钩子区域
  useEffect(()=>{
    if (radio) {
      setSelectedKeys(config.selectNode);
    } else {
      setCheckedKeys(config.selectNode);
    }
  },[config.selectNode])
  // 树节点选中  点击
  const onSelect = (selectedKeys, info) => {
    setSelectedKeys(selectedKeys);
    config.menSetChange && config.menSetChange(selectedKeys, info)
  };
  // 树节点选中  复选框
  const onCheck = (checkKeys, info) => {
    setCheckedKeys(checkKeys.checked);
    config.menSetChange && config.menSetChange(checkKeys, info)
  }
  // 展开树节点
  const onExpand = (expandKeys, info) => {
    setExpandedKeys(expandKeys);
    config.menOnExpand && config.menOnExpand(expandKeys, info)
  }
  if(treeData.length===0){
        return null;
  }
  return <>
      <div className="menTreeSearBox">
              <Search placeholder="输入名称 按下 Enter 搜索  " onSearch={(value)=>{
                setSearValue(value);
                setSearTreeData(createTreeData(menAction[id].dataMap,value))
        }} enterButton />
      </div>
      {searValue?<Tree
        showLine
        switcherIcon={<DownOutlined />}
        // defaultExpandedKeys={['0-0-0']}
        onSelect={onSelect}
        onCheck={onCheck}
        onExpand={onExpand}
        treeData={searTreeData}
        // 选中 复选框
        {...checkedKeysObj}
        // 默认展开
        {...defaultExpandedKeysObj}
        // 选中 点击
        {...selectedKeysObj}
        // 展开 节点 
        {...expandedKeysObj}
        // antd 树 props 
        {...treeConfig}

      >
        {/* <TreeNode 
          
          title= {<span
          onClick={(e)=>{
              e.stopPropagation();
              e.persist()
          }}
              onDoubleClick={(e,...ars)=>{
              e.stopPropagation()
      }}>
              模拟
          </span>}
          key= '0-0-2'
        >
              <TreeNode 
              title= 'parent 1-2'
              key= '0-0-4'
              ></TreeNode>
        </TreeNode> */}

  </Tree>:<Tree
        showLine
        switcherIcon={<DownOutlined />}
        // defaultExpandedKeys={['0-0-0']}
        onSelect={onSelect}
        onCheck={onCheck}
        onExpand={onExpand}
        treeData={treeData}
        // 选中 复选框
        {...checkedKeysObj}
        // 默认展开
        {...defaultExpandedKeysObj}
        // 选中 点击
        {...selectedKeysObj}
        // 展开 节点 
        {...expandedKeysObj}
        // antd 树 props 
        {...treeConfig}

      >
        {/* <TreeNode 
          
          title= {<span
          onClick={(e)=>{
              e.stopPropagation();
              e.persist()
          }}
              onDoubleClick={(e,...ars)=>{
              e.stopPropagation()
      }}>
              模拟
          </span>}
          key= '0-0-2'
        >
              <TreeNode 
              title= 'parent 1-2'
              key= '0-0-4'
              ></TreeNode>
        </TreeNode> */}

  </Tree>}
      
  </>
}
export const menCreateMenTree = (id, config) => {
  return <MenTree id={id} config={config}></MenTree>
}
// const
export default {
  menCreateMenTree,
  menSetTreeData,
  menGetTreeSelected,
  menGetTreeData
};