//复合搜索框
import SearRefComponent from "./searRefComponent";
import Hyperlink from "./Hyperlink";
import HuoHuaUpload from "./HuoHuaUploadBox/Upload.js";
import CustomButtonSon from "./CustomButton/index.js";
import SonOperationSon from "./SonOperation/index";
// 富文本编辑器
import MenBraftEditorSon from "./RichText"
// 评论组件 Comment
import Comment from "./Comment"
import {
  useField, useForm
} from '@formily/react'

export const SearRefComponentBox = (props) => {
  let Field = useField();
  let Form = useForm();
  // 单多之别  有无之分
  let value = [];
  if(props.value){
    if(props["mode"]==="multiple"){
      if(typeof props.value === "string"){
        value = JSON.parse(props.value);
      }else{
        value = props.value;
      }
    }else{
      value = [
        {
          label: props.value.label || "",
          value: props.value.value || ""
      
        }
      ]
    }
  }else{
    value = []
  }
  return <SearRefComponent  setChange={(ars) => {
    let key = Field.props.name;
    let val = {
      value: "",
      label: "",
    }
    if(props["mode"]==="multiple"){
      val = ars
      
    }else{
      val = {
        value: ars[0]&&ars[0].value||"",
        label: ars[0]&&ars[0].label||"",
      }
    }
    props.onChange.call(null, val)
  }}
  {...props}
  value={value}
  ></SearRefComponent>
}
export const SearListBox = (props) => {
  let Field = useField();
  let Form = useForm();
  return <SearRefComponent
            value={{
              label: props.value && props.value.label || "",
              value: props.value && props.value.value || ""

            }} 
        setChange={(...ars) => {
          let key = Field.props.name;
          let val = {
            value: ars[0].value,
            label: ars[0].label,
          }
          // Field.setValue(val)
          props.onChange.call(null, val)
          // 
          // props.dispatch({
          //   type: 'budgetMatters/saveFormSingle',
          //   payload: {
          //     formData: {
          //       budgetDepartmentName: ars[0].label,
          //       budgetDepartment: ars[0].value
          //     }
          //   }
          // });
        }}
    ></SearRefComponent>
}
// 超链接组件
export const HyperlinkBox = (props) => {
  let Field = useField();
  let Form = useForm();
  return <a
        onClick={()=>{
          let key = Field.props.name;
          props.onChange.call(null, {
            label: props.value && props.value.label || "",
            value: props.value && props.value.value || ""
          })
        }}
    >
      {props.value.label}
    </a>
}

// 上传组件
export const HuoHuaUploadBox=(props)=>{
  
  let Field = useField(); 
  let Form = useForm();
  let {extension,value=[],...otherProps} = props;
  let {request_url,...otherExtension} = extension;
  let newValue;
  if(!Array.isArray(value)){
      newValue = value.fileList;
  }else{
    newValue = value;
  }
  return <HuoHuaUpload
   {...otherProps}
    {...otherExtension}
     action={request_url}
     fileList ={newValue}  ></HuoHuaUpload>
}

// 自定义按钮组件
export const CustomButton = (props={})=>{
  return <CustomButtonSon {...props}></CustomButtonSon>
}

// 操作列组件
export const SonOperation = (props={})=>{
  let Field = useField(); 
  let Form = useForm();
  return <SonOperationSon {...props} Field={Field} Form={Form} ></SonOperationSon>
}
// 富文本编辑器 MenBraftEditorSon

export const MenBraftEditor = (props={})=>{
  let Field = useField(); 
  let Form = useForm();
  let {onChange,value,...otherProps} = props;
  return <MenBraftEditorSon {...props} Field={Field} Form={Form}
  value={value}
   setChange = {(val)=>{
    console.log("点击确定时的数据",val);
    onChange.call(null, val)
  }} ></MenBraftEditorSon>
}
// 评论组件
// MenComment
export const MenComment = (props={})=>{
  let Field = useField(); 
  let Form = useForm();
  let {onChange,value,...otherProps} = props;
  return <Comment {...props} Field={Field} Form={Form}
  value={value}
   setChange = {(val)=>{
    console.log("点击确定时的数据",val);
    onChange.call(null, val)
  }} ></Comment>
}
