import React, { useEffect, useState } from 'react';
import { Select, message, Spin } from 'antd';
import "./index.less";
const { Option } = Select;
import { UnorderedListOutlined } from "@ant-design/icons";
import Refer from "./refer";
import debounce from 'lodash/debounce';
let timeout;
let currentValue;
// let EMPTYTXT = "当前输入的数据不存在"
/*
time ：time 防抖间隔
"mode":"multiple",//是否多选  multiple | tags 单
onHandleSearch ：fn 每次搜索获取结果后的回调 参数 value list state
disposeCallBackData：fn 每次获取数据以后可以使用该方法转化 必须返回数组  {label:"",value:""}
onHandleChange:fu 每次结果值发生变化时回调
EMPTYTXT:"" ,搜索数据为空时提示语句,
modal:{//是否开启弹窗模式选择数据  内部为弹窗相关配置
      title:"部门",
      isSearch:false,// 是否需要搜索
      placeholder:"搜索提示",
      isAsync:true,// 是否是异步树   
      treeUrl:"/ehr/department-tree",
      requestParameter:{},
      isPc:true,// 是否是pc
}
*/
function DebounceSelect({ fetchOptions, debounceTimeout = 800, ...props }) {
  const [fetching, setFetching] = React.useState(false);
  const [options, setOptions] = React.useState([]);
  const fetchRef = React.useRef(0);
  const debounceFetcher = React.useMemo(() => {
    const loadOptions = (value) => {
      fetchRef.current += 1;
      const fetchId = fetchRef.current;
      setOptions([]);
      setFetching(true);
      fetchOptions(value).then((newOptions) => {
        if (fetchId !== fetchRef.current) {
          // for fetch callback order
          return;
        }

        setOptions(newOptions);
        setFetching(false);
      });
    };

    return debounce(loadOptions, debounceTimeout);
  }, [fetchOptions, debounceTimeout]);
  const optionsDom = options.map(d => <Option key={d.value} label={d.label}><span aria-label={d.label}> {d.label}</span> <span style={{fontSize:14,color:"#ccc",fontWeight:800}}>{   d.mark}</span></Option>);

  return (
    <Select
      labelInValue={true}
      filterOption={false}
      onSearch={debounceFetcher}
      notFoundContent={fetching ? <Spin size="small" /> : null}
      {...props}
    >
      {optionsDom}
    </Select>
  );
}


const SearchInput = (props = {}) => {
  let [data, setData] = useState([]);
  let [value, setValue] = useState(props.value);
  let [emptyTxt, setEmptyTxt] = useState(props.emptyTxt);
  let [modalVisible, setModalVisible] = useState(false);
  let { time, onHandleSearch, disposeCallBackData, onHandleChange, EMPTYTXT, extension } = props;
  let {modal,wr_search=true} = extension;
  const fetch = (value, callback) => {
    // let {timeout} = props;
    if (timeout) {
      clearTimeout(timeout);
      timeout = null;
    }
    currentValue = value;
    async function fake() {
      if (!props.extension.request_url) {
        return [];
      }
      let data = await fetchUserList(value);
      callback(data)

    }
    timeout = setTimeout(fake, time);
  }
  // 多选请求
  const fetchUserList = async (val) => {
    if (!props.extension.request_url) {
      return;
    }
    let queryCondition = {};
    if(props.extension.queryCondition instanceof Function){
      queryCondition = {
        ...props.extension.queryCondition()
      }
    }else{
      queryCondition = {
        ...props.extension.queryCondition
      }
    }
    if(window?.menRequest){
        return window?.menRequest.get(props.extension.request_url,{
          params:{keyWords:val}
        })
          .then((response) => {
            // 模拟BB
            let data = [];
            if(response.data){
              //  
              return response.data
            }
            // if(data.length>0){
            //   setData(data);
            // }else{
    
            // }
            return data;
          });
    }else{
      console.warn("windows 上 需要 全局变量 menRequest 作为 请求方法使用 可在挂载该方法前写入默认参数")
    }
    
  }
  // props props.value 发生变化 并且和当前value 不一样 那需要按照新的props去渲染
  useEffect(() => {
    setValue(props.value)
  }, [props.value]);

  const handleSearch = async (value) => {
    let { EMPTYTXT } = props;
    // return;
    if(!value&&props.extension.focus_data){
      fetch(value, (data) => {
        if (data.length > 0) {
          setData(data);
          setEmptyTxt("")
        } else {
          setData(data);
          setEmptyTxt(EMPTYTXT)
        }
      });
      return ;
    }
    if (value) {
      fetch(value, (data) => {
        if (data.length > 0) {
          setData(data);
          setEmptyTxt("")
        } else {
          setData(data);
          setEmptyTxt(EMPTYTXT)
        }
      });
    } else {
      setData([]);
      setEmptyTxt("")
    }
  };
  const handleChangeConfig = {
    // 是否是多选
    "mode": (res, ars, callback) => {
      // 多选
      if (ars[2]) { 
        return ars[0]
      }
    //  单选
      if (res) {
        return ars[0]
      } else {
        return [ars[0]]
      }

    }
  }
  const handleChange = (...ars) => {
    let data = handleChangeConfig["mode"](props["mode"]==="multiple", ars);
    setValue([...data]);
    if (props.setChange) {
      props.setChange(data)
    }
  };
  // const setmodalVisible = (v)=>{
  //   setState({modalVisible:v})
  // }
  
  // 获得焦点是否请求数据
  let onFocus = {};
  if(props.extension.focus_data){
    onFocus = {
      onFocus:()=>{
          handleSearch("")
      }
    }
  }
  let wr_search_class = "";
  if(!wr_search&&(!props.disabled)){
    wr_search_class = "wr_search_yes"
  }
  
  if (props["mode"]==="multiple") {
    return <>
      {modal ? <Refer setChange={handleChange}
        modalVisible={modalVisible}
        {...modal}
         request_url ={props.extension.modal.request_url||props.extension.request_url} 
        mode={props["mode"]}

         setmodalVisible={setModalVisible}
         selectNode={value.map(i=>i.value)} ></Refer> : null}


      <div className="searRefComponent-box">
        <DebounceSelect
          mode="multiple"
          className="searRefComponent-content searRefComponent-multiple"
          value={value}
          disabled={props.disabled}
          placeholder={props.placeholder}
          fetchOptions={fetchUserList}
          optionLabelProp="label"
          onChange={(newValue) => {
            // setValue(newValue);
            handleChange(newValue)
          }}
          style={{
            width: '100%',
          }}
        />
        <div className="searRefComponent-title">
          {emptyTxt}
        </div>
        {modal ? <div className="searRefComponent-icon">
          <UnorderedListOutlined className="UnorderedListOutlined" onClick={() => {
            setModalVisible(true)
            // events.budgetDepartmentChange(ars,props)
          }} />
        </div> : null}

      </div>
    </>
  } else {
    const options = data.map(d => <Option key={d.value} label={d.label}><span aria-label={d.label}> {d.label}</span> <span style={{fontSize:14,color:"#ccc",fontWeight:800}}>{   d.mark}</span></Option>);
    return (
      <>
        {modal ? <Refer setChange={handleChange}
          modalVisible={modalVisible}
          {...modal}
          request_url ={props.extension.modal.request_url||props.extension.request_ur} 
           
          x-multiple={props["x-multiple"]}
          setmodalVisible={setModalVisible} selectNode={value.map(i=>i.value)}></Refer> : null}
        <div className="searRefComponent-box">
          <Select
            labelInValue={true}
            // mode = "multiple"
            disabled={props.disabled||!wr_search}
            className={"searRefComponent-content " +wr_search_class}
            showSearch
            value={value[0]}
            placeholder={props.placeholder}
            // style={props.style}
            // defaultActiveFirstOption={false}
            showArrow={false}
            filterOption={false}
            onSearch={handleSearch}
            onChange={handleChange}
            notFoundContent={null}
            optionLabelProp="label"
            {...onFocus}
            // options={data}
            // tagRender={(node)=>{
            // }}
          >
            {options}
          </Select>
          <div className="searRefComponent-title">
            {emptyTxt}
          </div>
          {modal&&(!props.disabled) ? <div className="searRefComponent-icon">
            <UnorderedListOutlined className="UnorderedListOutlined" onClick={() => {
              setModalVisible(true)
              // events.budgetDepartmentChange(ars,props)
            }} />
          </div> : null}

        </div>
      </>
    );
  }

}
SearchInput.defaultProps = {
  time: 300,  // 防抖间隔
  onHandleSearch: null,// fn 每次搜索获取结果后的回调 参数 value list state
  disposeCallBackData: null,// fn 每次获取数据以后可以使用该方法转化 必须返回数组  {label:"",value:""}
  onHandleChange: null,// fu 每次结果值发生变化时回调
  EMPTYTXT: "当前输入的数据不存在", // 搜索数据为空时提示语句,
  // "mode": "multiple",//是否是多选
  extension:{
    // "queryCondition": {
    //   // defaultKey:"",//表单设计时可以填入默认参数
    //   // key:[],// 动态规则 该规则主要用于关联当前页表单 依赖当前页某一些项的数据 如果不满足 将不能选择 该参数不仅仅是在远端请求会用 现有的组件也将校验该参数  已确定 是否可以选择
    // }, //表单项的 title
    // "request_url": 'https://randomuser.me/api/?results=5', //远端数据时 数据请求地址
    // modal:{//是否开启弹窗模式选择数据  内部为弹窗相关配置 null 的时候 不开启弹窗能力
  //       title:"部门",
  //       isSearch:false,// 是否需要搜索
  //       placeholder:"搜索提示",
  //       isAsync:true,// 是否是异步树   
  //       treeUrl:"/ehr/department-tree",
  //       requestParameter:{},
  //       isPc:true,// 是否是pc
  //       isCheck:false,//是否开启复选状态  待开发
  // }
  },
  value: {},
  
}
export default SearchInput;



// const Demo = () => {
//   const [value, setValue] = React.useState([]);
//   return (

//   );
// };

// export default Demo;
