import { Modal, Input, Spin } from 'antd';
import React, { useState, FC,useEffect  } from "react"
import { getTreeData, recursionTreeNode } from "./meth";
import {guid} from "../../../util";
import menTree from "../../../MenTree/exports.js"
import  "./index.less";

const SpinBox = (props: any) => {
  return (props.spinning ? <div className="example">
  <Spin tip="Loading..." size="large" {...props} />
</div> : null)
}
const App  = (props:any) => {
  const [spinning, setSpinning] = useState(true);
  const [treeUid,setTreeUid] = useState(guid())
  // 是否多选  多选开启复选框
  let xMultiple = props["mode"]==="multiple";
  useEffect(()=>{
    if((menTree.menGetTreeData(treeUid)&&menTree.menGetTreeData(treeUid).length===0)&&props.modalVisible){
      getTreeData({
        url: props.request_url,
        params: {
          rootDepId: "0"
        }
      }).then((res: { data: any; }) => {
        let data:any = [];
        if(res&&res.data){
          data = [res.data];
        }
        menTree.menSetTreeData(treeUid,recursionTreeNode({
          data,
          title: props.title
        }))
        setSpinning(false);
      }, (err: any) => {
        console.error("请求树数据错误", err);
      })
    }
  },[props.modalVisible])
  const handleOk = () => {
   let selects = menTree.menGetTreeSelected(treeUid);
    if(props.setChange){
      try {
        props.setChange(selects,[],true);
        
      } catch (error) {
        console.error(error)
      }
    }
    setVisible({
      modalVisible: false,
    });
  };
  const setVisible = (payload: any) => {
    props.setmodalVisible(payload.modalVisible)
  }
  const handleCancel = () => {
    try {
      if(props.handleCancel){
        props.handleCancel()
      };
      
    } catch (error) {
      console.error(error)
    }
    setVisible({
      modalVisible: false,
    });

  };
  return (
    <Modal
      title={props.title || "title"}
      maskClosable={false}
      okText="确认"
      cancelText="取消"
      centered={true}
      width={800}
      visible={props.modalVisible}
      onOk={handleOk}
      onCancel={handleCancel}
    >
      <SpinBox spinning={spinning}></SpinBox>
      <div className={"pc-modal-content"}>
        

        <div className={"pc-modal-tree-content"}>
          {menTree.menCreateMenTree(treeUid,{
                 selectNode:props.selectNode,
                 radio:!xMultiple,
                 menSetChange:(res:any)=>{
                 }
          })}
        </div>
      </div>
    </Modal>
  );
};

export default App