import React, { useState, useEffect } from 'react';
import menGlobal from "../global";
import * as disposeMethod from "./method/disposeMethod"
import { calculate } from "./method/calculateMethod";
import {
    useField, useForm
  } from '@formily/react';
import {
    createForm, FormPath,
    onFormInputChange, onFieldValueChange,
    onFieldChange,
    onFieldInputValueChange,
    onFieldReact
} from '@formily/core'
import { createSchemaField } from '@formily/react'
import * as FormilyAntd from '@formily/antd'
import { action } from '@formily/reactive'
import MenModal from "../Modal/exports";
import MenLoding from "../MenLoding/exports"
import * as custom from '../comm'
import * as util from '../util/index';
import schemaFieldItems from "./method/schemaFieldItems"
import { reqexCinfig } from "../constant/regex"
import calculate_meth from "./fixed_calculate"
import { Tabs, Card, message ,Button} from 'antd'
import * as ICONS from '@ant-design/icons';
import _ from "lodash";
import 'antd/lib/tabs/style'
import 'antd/lib/button/style';
import "./index.less"
let menAction = {};
// 扩展组件
let menActionComponents = {}
// 全局计数器
let count = 0;
// 全局设置输入型表单
let inputType = new Set(["Input.TextArea", "Input"]);
// 扩展组件的方法 需要返回对象  key:value  组件名称 组件 变量 
// 提供内部一定的变量
const menAddFormComponents = async (callback)=>{
    let com = await callback({
        util:util,
        useField, 
        useForm
    });
    menActionComponents = Object.assign({},menActionComponents,com);
}
// 设置表单模板
const menSetFormMeta = (id, data, callback) => {
    // 需要校验数据合法性
    if (menAction[id] && menAction[id].setData && menAction[id].setMeta) {

        menAction[id] && menAction[id].setMeta && menAction[id].setMeta(data, callback);

    } else {
        console.warn("setFormMeta 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
// 设置某个单独表单项 模板 
const menSetFormKeyMeta = (id, key, data = {}, callback) => {
    // 需要校验数据合法性
    if (menAction[id] && menAction[id].setData && menAction[id].setMeta) {
        let meta = menAction[id].getMeta();
        if (key && meta.properties && meta.properties[key]) {
            meta.properties[key] = Object.assign(meta.properties[key], data)
            menAction[id].setMeta(meta, callback);
        } else {
            console.warn("menSetFormKeyMeta 当前设置时机不对 实例不存在 或者 传入 id  key错误 !Mendege")
        }


    } else {
        console.warn("menSetFormKeyMeta 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
// 获取某一项表单模板  暂时只支持 一级访问 后续会增加访问层级
const menGetFormKeyMeta = (id, key) => {
    // 需要校验数据合法性
    if (menAction[id] && menAction[id].setData && menAction[id].setMeta) {
        let meta = menAction[id].getMeta();
        if (key && meta.properties && meta.properties[key]) {
            return meta.properties[key];
        } else {
            console.warn("menGetFormKeyMeta 当前设置时机不对 实例不存在 或者 传入 id  key错误 !Mendege")
        }


    } else {
        console.warn("menGetFormKeyMeta 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
const menGetFormMeta = (id) => {
    // 需要校验数据合法性
    if (menAction[id] && menAction[id].setData && menAction[id].setMeta) {
        let data = menAction[id] && menAction[id].setMeta && menAction[id].getMeta();
        return data;
    } else {
        console.warn("setFormMeta 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
// 设置表单数据 key  是否按照key去设置
const menSetFormData = (id, data, key) => {
    if (menAction[id] && menAction[id].setData) {
        if (key) {
            menAction[id].setData({ ...menAction[id].getData(), [key]: data }, true)
        } else {
            menAction[id].setData(data, true)
        }
    } else {
        console.warn("menSetFormData 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
// 获取 表单数据 key 没有key 全量  有key 单独数据
const menGetFormData = (id, key) => {
    if (menAction[id] && menAction[id].setData && menAction[id].getData()) {
        if (key) {

            return menAction[id].getData()[key] || undefined;
        } else {
            let data = menAction[id].getData();

            util.absAcc(data, (res) => {
                // 处理数据   后续可能递归
                let metaKey = menGetFormKeyMeta(id, res[0])||{};
                let xm = metaKey["x-component"];
                // 上传 fileList
                if (xm === "HuoHuaUploadBox") {
                    let items = [];

                    util.absAcc(res[1], (resd) => {
                        if (resd.response) {
                            items.push(resd.response.data)
                        } else {
                            items.push(resd)
                        }
                    })
                    data[res[0]] = items;
                }

            })
            return data
        }
    } else {
        console.warn("menGetFormData 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege");

    }
}
// 获取表单实例 id 不存在则返回所有表单实例
const menGetFormInstance = (id) => {
    if (typeof id === "undefined") {
        let instances = [];
        for (const key in menAction) {
            if (Object.hasOwnProperty.call(menAction, key)) {
                const element = menAction[key].instance;
                if (element) {
                    instances.push({
                        id: key,
                        instance: element()
                    });
                }
            }
        }

        return instances;
    } else {
        if (menAction[id] && menAction[id].instance && menAction[id].instance) {
            return menAction[id].instance();
        } else {
            console.warn("menGetFormInstance 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
        }
    }
}
// 手动触发校验
const verifyForm = (id, type = "",optionType="") => {
    if (menAction[id] && menAction[id].instance) {
        return new Promise((reslove, reject) => {
            menAction[id].instance().submit().then((res) => {
                let data = {
                    success: true,
                    data: res
                }

                if(menAction[id].readOnlyValidator&&optionType==="submit"){
                    util.absAcc(menAction[id].readOnlyValidator,(itemsList,stops)=>{
                        if(itemsList[1]){
                            message.error(`${itemsList[0]} ： ${itemsList[1]}`);
                            stops.go_on = false;
                            reslove(false);

                        }
                    })

                    
                }
                for (const key in res) {
                    if (Object.hasOwnProperty.call(res, key)) {
                        const element = res[key];
                        let meta = menGetFormKeyMeta(id, key);
                        if (meta && Object.prototype.toString.call(element) === '[object Object]' && meta["required"]) {
                            if (!element.value) {
                                message.warning(`${meta.title}不能为空！`);
                                reslove(false)
                                break;
                            }
                        }
                         if(!meta){
                            continue;
                        }
                        // 处理数据   后续可能递归
                        let xm = meta["x-component"];
                        // 上传 fileList
                        if (xm === "HuoHuaUploadBox") {
                            let isReturn = false;
                            util.absAcc(element, (resd) => {
                                if (resd.status !== "done") {
                                    isReturn = true;
                                }
                            })
                            if (isReturn) {
                                message.warning(`正在上传附件！`);
                                reslove(false)
                                break;
                            }
                        }

                    }
                }
                if (type === "boolean" || typeof type === "boolean") {
                    data = true;
                }
                reslove(data)

            }, (err) => {
                let data = {
                    success: false,
                    data: err
                }
                if (type === "boolean" || typeof type === "boolean") {
                    data = false;
                }
                reslove(data)
            })
        })

    } else {
        console.warn("verifyForm 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
// 全局 stop
const menGetStop = (id) => {
    if (menAction[id] && menAction[id].instance) {
        return menAction[id].stop
    } else {
        console.warn("verifyForm 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
const menSetStop = (id, data) => {
    if (menAction[id] && menAction[id].instance) {
        menAction[id].stop = data
    } else {
        console.warn("verifyForm 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}
// 设置显示隐藏联动 主要是设置模板 单独设置
/* 
    effector :{//控制者数据
        key:"",//控制者key
        // value:{}
        
    },
    controlled:{//受控者数据
        keys:[
            {
                value:[],//控制者value等于什么 该key 显示 数组
                key:"",//具体key
            }
        ]//被控制者 key 数组 
    }
*/
const menSetShowHidden = (id, con = {}, res) => {
    if ((menAction[id] && menAction[id].instance) || res) {
        let { effector, controlled } = con;
        let meta = {};
        if (res) {
            meta = res
        } else {
            meta = menGetFormMeta(id)
        }
        let properties = meta.properties;
        let element = properties[effector.key];
        if (!element) {
            console.warn(`menSetShowHidden 当前模板中 控制者 ${effector.key} 不存在 !Mendege`);
            return;
        }
        if (element["x-reactions"]) {

        } else {
            if (!Array.isArray(controlled.keys)) {
                console.warn(`menSetShowHidden 当前模板中 受控制者 参数 controlled.keys 必须为数组  !Mendege`);
            }
            let targets = controlled.keys.map(i => i.key);
            let targetsAll = true;
            if (!Array.isArray(targets)) {
                console.warn(`menSetShowHidden 当前模板中 受控制者 参数 controlled.keys[n].key 必须存在  !Mendege`);
            }
            let vauleKey = {

            }
            controlled.keys.forEach((i, k) => {
                if (Array.isArray(i.value)) {
                    i.value.forEach((a, b) => {
                        if (vauleKey[a]) {
                            vauleKey[a] = vauleKey[a] + "," + i.key;
                        } else {
                            vauleKey[a] = i.key;
                        }

                    })
                    targetsAll = false;
                }

            });
            vauleKey._targetsAll_ = targetsAll;
            let scode = (val, $target) => {
                let display = false;
                if ($target.props) {
                    let targetName = $target.props.name;
                    if (vauleKey[val.value] && vauleKey[val.value].indexOf(targetName) != -1) {
                        display = true
                    }
                }

                return display;
            }
            let scodeKeys = effector.key + "_linkage";
            element["x-reactions"] = {
                target: `*(${targets.join(",")})`,
                fulfill: {
                    state: {
                        visible: `{{${scodeKeys}($self,$target)}}`
                    },
                },
            }

            properties[effector.key] = element;
            menAction[id].setScope({ ...menAction[id].getScope(), [scodeKeys]: scode })
            menAction[id].setMeta(meta);
        }

    } else {
        console.warn("menSetShowHidden 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}

const menSetShowHiddenAll = (id, ars, res) => {
    if ((menAction[id] && menAction[id].instance) || res) {
        let meta = {};
        if (res) {
            meta = res
        } else {
            meta = menGetFormMeta(id)
        }
        ars.forEach((items, itemsIndex) => {
            let { effector, controlled } = items;
            let properties = meta.properties;
            let element = properties[effector.key];
            if (!element) {
                console.warn(`menSetShowHidden 当前模板中 控制者 ${effector.key} 不存在 !Mendege`);
                return;
            }
            if (element["x-reactions"]) {

            } else {
                if (!Array.isArray(controlled.keys)) {
                    console.warn(`menSetShowHidden 当前模板中 受控制者 参数 controlled.keys 必须为数组  !Mendege`);
                }
                let targets = controlled.keys.map(i => i.key);
                let targetsAll = true;
                if (!Array.isArray(targets)) {
                    console.warn(`menSetShowHidden 当前模板中 受控制者 参数 controlled.keys[n].key 必须存在  !Mendege`);
                }
                let vauleKey = {

                }
                controlled.keys.forEach((i, k) => {
                    if (Array.isArray(i.value)) {
                        i.value.forEach((a, b) => {
                            if (vauleKey[a]) {
                                vauleKey[a] = vauleKey[a] + "," + i.key;
                            } else {
                                vauleKey[a] = i.key;
                            }

                        })
                        targetsAll = false;
                    }

                });
                vauleKey._targetsAll_ = targetsAll;
                let scode = (val, $target) => {
                    let display = false;
                    if ($target.props) {
                        let targetName = $target.props.name;
                        if (vauleKey[val.value] && vauleKey[val.value].indexOf(targetName) != -1) {
                            display = true
                        }
                    }


                    return display;
                }
                let scodeKeys = effector.key + "_linkage";
                element["x-reactions"] = {
                    target: `*(${targets.join(",")})`,
                    fulfill: {
                        state: {
                            display: `{{${scodeKeys}($self,$target)}}`
                        },
                    },
                }

                properties[effector.key] = element;
                menAction[id].setScope(scodeKeys, scode)
            }
        })
        menAction[id].setMeta(meta);

    } else {
        console.warn("menSetShowHidden 当前设置时机不对 实例不存在 或者 传入id错误 !Mendege")
    }
}

// 简单下拉 请求函数
const useAsyncDataSource = (pattern, service, id) => {
    onFieldReact(pattern, async (field) => {
        field.loading = true
        await service(field).then(
            action(async (data) => {
                if (!data.stop) {
                    let datas = data.data;
                    field.dataSource = datas.data;
                    field.loading = false;
                    menSetFormKeyMeta(data.id, data.key, {
                        enum: datas.data
                    })
                    if (menGetFormKeyMeta(data.id, data.key)["x-component-props"]["extension"].wr_default_first&&Array.isArray(datas.data)&&datas.data.length) {
                        
                        menGetFormInstance(id).setValuesIn(menGetFormKeyMeta(data.id, data.key).key, datas.data[0].value)
                        menAction[id].menOnChangeBox(id, data.key, undefined, datas.data[0].value)
                        menSetFormData(id, datas.data[0].value, data.key);
                    }

                } else {
                    field.loading = false;
                }

            })
        )
    })
}
// 销毁组件
const menDestroy = (ids) => {
    if (typeof ids === "undefined") {

        menAction = {};
        return
    }
    if (typeof ids === "string") {
        if (menAction[ids]) {
            delete menAction[ids];
        } else {
            console.warn(`menDestroy 当前上下文中 ${ids} 不存在 !Mendege`);
        }
        return
    }
    if (Array.isArray(ids)) {
        ids.forEach((i) => {
            if (menAction[i]) {
                delete menAction[i];
            } else {
                console.warn(`menDestroy 当前上下文中 ${i} 不存在 !Mendege`);
            }
        })
        return
    }

}

/* 创建 表单
id：必须参数 唯一标识
formConfig 直接传给formily 的配置
components 外部组件可直接传入 配合模板 以后能借用formily 组件系统渲染
menOnChange 表单编辑后事件 参数如下
    id, key 当前表单项 , prevValue 上一次表单编辑后的值, value 当前表单的值, Form 当前表单实例 , Field 当前表单项实例
menOnbeforeChange 表单编辑钱事件 暂未开发 
*/
const menCreateForm = (id, con = {}) => {
    let { components = {}, menOnbeforeChange, menOnChange, formConfig = {} } = con;
    if (!menAction[id]) {
        menAction[id] = {
            state: {},//数据队列
            stop: false,//三个状态 1 开始停止  2  停止准备中  3  停止  只有在一个地方才能彻底停止 
            xValidator: new Map(),//"原始校验规则"
            scope: {},//协议等内部使用方法 合集
            readOnlyValidator:{}
        };
    }
    menAction[id].config = con;
    if (!menAction[id].hisData) {
        menAction[id].hisData={};
    }
    menAction[id].inputTypeKeys = new Set();// 输入组件 key  系列
    let [dataSource, setDataSource] = useState(con.data || {});
    let [meta, setMeta] = useState(con.meta || {});
    const setState = async (state) => {
        await setDataSource(menAction[id].state)
    }
    // 组件首次加载
    useEffect(() => {
        return () => {
            delete menAction[id]
            menGlobal.deleteInstance(id);
        }
    }, [])

    useEffect(() => {
        if (menAction[id]) {
            if (!_.isEqual(menAction[id].state, dataSource)) {
                setState(menAction[id].state)
            }
        }
        // 每次修改需要为当前表单 挂载操作真实dom
        // men-select-readonly
        // 设置只读 .setAttribute("readonly","readonly")
        if (util.getClassNode(".men-select-readonly .ant-select-selection-search-input")) {
            util.getClassNode(".men-select-readonly .ant-select-selection-search-input").forEach((i) => {
                i.setAttribute("readonly", "readonly")
                i.setAttribute("disabled", true)
            })
        }
        // 除去title  ant-select-selection-item
        if (util.getClassNode(".ant-select-selection-item")) {
            util.getClassNode(".ant-select-selection-item").forEach((i) => {
                i.removeAttribute("title")
            })
        }



    })

    menAction[id].setData = (res, flag) => {
        menAction[id].state = _.cloneDeep(res);
        // 特殊情况下
        if(menAction[id].instance&&flag==="instance"){
            menAction[id].instance().setValues(menAction[id].state)
        }
        if (flag===true) {
            setDataSource(menAction[id].state);
        }
    };
    menAction[id].setMeta = (res, callback) => {

        if (callback) {
            callback(res)
        } else {
            setMeta({ ...res });
        }
    };
    menAction[id].setScope = (key, callback) => {
        menAction[id].scope[key] = callback;
    };
    menAction[id].getScope = () => {
        return menAction[id].scope || {};
    };
    menAction[id].getMeta = (key) => {
        return meta;
    };
    menAction[id].metaMap={}
    menAction[id].getData = () => {
        let values = menAction[id].instance().getFormState().values;
        if(!_.isEqual(menAction[id].state, values)){ 
            menAction[id].state = values;
        }
        return _.cloneDeep(menAction[id].state);
    };

    if (con.debugger) {
        debugger;
    }
    if (!meta.properties) {
        return null;
    }
    menAction[id].instance = () => {
        return normalForm
    };
   
    // 编辑后事件中间件 远程校验使用 表示校验失败
    const menOnChangeBox = (...ars) => {
        console.log("统一编辑后事件",ars);
        let isReturn = false;
        let keyMeta = menGetFormKeyMeta(id,ars[1]);
        let key = ars[1];
        // 清空 暂时校验
        menAction[id].readOnlyValidator = {}
        // 判断本处的值是否严格控制其他项的值 若存在严格控制 需要弹出提示框 提示 并且实现清空以及回退的操作 协议控制
        let in_control_flag = keyMeta&&keyMeta["x-component-props"]&&keyMeta["x-component-props"]["extension"]&&keyMeta["x-component-props"]["extension"]["wr_null_check"]
        if(in_control_flag){
            let wr_null_check = keyMeta["x-component-props"]["extension"]["wr_null_check"];
            let title_str = wr_null_check.title.join("  ");
            let key_list_value = menAction[id].instance().getFieldState(wr_null_check.key_list[0]);

            if(key_list_value.value&&key_list_value.value.length>0){
                // 切换需要提示
                isReturn = true;
                setTimeout(()=>{
                    MenModal.menModalShow(id+"_hint",{
                        title:"提示",
                        content: (state, setState) => {
                            return `切换${keyMeta.title}将会导致${title_str}已选数据被清空，请问确定切换吗？`
                        },
                        confirmClick: async (state) => {
                            menAction[id].instance().setValuesIn(wr_null_check.key_list[0],[]);
                            if(menAction[id].hisData[key]){
                                ars[2]=_.cloneDeep(menAction[id].hisData[key]);
                            }else{
                                ars[2] = undefined;
                            }
                            menAction[id].hisData[key] = ars[3];
                            menOnChange&&menOnChange(...ars)
                            MenModal.menModalClose(id+"_hint")
                        },
                        cancelClick:()=>{
                            // 如果取消  那需要
                            menAction[id].instance().setValuesIn(key,menAction[id].hisData[key]);
                            MenModal.menModalClose(id+"_hint")
                        }
                    })
                },10)
            }
            
           
            
        }
        if(!isReturn){
            if(menAction[id].hisData[key]){
                ars[2]=_.cloneDeep(menAction[id].hisData[key]);
            }else{
                ars[2] = undefined;
            }
            menAction[id].hisData[key] = ars[3];
            menOnChange&&menOnChange(...ars)
        }
        
    }
    menAction[id].menOnChangeBox = menOnChangeBox;
    // 浏览态需要特定 class 区别样式
    let editable = true;
    let editClass = "men-form-box-noDisabled";
    if (meta.editable === false) {
        editable = false;
        editClass = "men-form-box-disabled"
    }
    // 固定计算规则
    let fixed_calculate_rules = new Map();
    // 简单远程下拉
    let simpleness_telnet_select = new Map();
    // 处理表单模板 需要将自定义的规则以及协议转换成formily 支持的协议
     disposeMethod.absAccFormItems(meta,meta.properties,(element,key)=>{
        let xCp = element["x-component-props"];
        // 收集模板信息
        menAction[id].metaMap[key]=element;
        // 挂载失去焦点
        disposeMethod.mountOutFocus({
            element, xCp, inputType, menAction, id, key, menOnChange:menOnChangeBox,
            dataSource, fixed_calculate_rules, simpleness_telnet_select, meta
        })
        // 即时校验规则置换 校验规则
        disposeMethod.instantCheck({ element, reqexCinfig,IDmenAction:menAction[id] });
        // 远程校验
        disposeMethod.remoteCalibration({ element, xCp, menAction, id, key, request:window.menRequest, meta })
        // 即时联动规则
        disposeMethod.linkageAgreement({ element, xCp, id, key, menAction })
        // 默认值改造
        disposeMethod.defaultValueDispose({ element, xCp, id, key, menAction })
        // tips 适配
        disposeMethod.consttipsNewline({ element, xCp, id, key, menAction })
    })

    const normalForm = createForm({
        validateFirst: true,
        values: menAction[id].state,
        effects(...value) {
            // 固定规则类计算 
            fixed_calculate_rules.forEach((i, k) => {
                if (calculate[i.type]) {
                    calculate[i.type]({ i, onFieldValueChange, menAction, calculate_meth, k, id,MenLoding });
                }
            });
            // 简单 远程下拉数据源 有依赖参数的 暂时未开发
            simpleness_telnet_select.forEach((i, k) => {
                useAsyncDataSource(k, async (field) => {
                    let key = field.props.name;

                    if (menGetStop(id)) {
                        return {
                            stop: true
                        }
                    }
                    let queryCondition = {};
                    if (i.queryCondition instanceof Function) {
                        queryCondition = {
                            ...i.queryCondition()
                        }
                    } else {
                        queryCondition = i.queryCondition;
                    }
                    menSetStop(id, true);
                    return new Promise((reslove, reject) => {
                        if(window.menRequest){
                            window.menRequest.get(i.request_url, {
                                params: queryCondition
                            }).then((data) => {
                                reslove({ data: data, id: id, key: key })
                            }, (err) => {
                                reject([])
                            })
                        }else{
                          console.warn("windows 上 需要 全局变量 menRequest 作为 请求方法使用 可在挂载该方法前写入默认参数")
                          reject([])
                        }
                        
                    })
                }, id)
            })
            // ++++++++
            onFieldInputValueChange('*', util.antiShake((Field, Form) => {
                let key = Field.props.name;
                let active = Field.active;
                let value = Form.values[key];
                let prevValue = menAction[id]&&menAction[id].getData()[key];
                if (!menAction[id].inputTypeKeys.has(key)) {
                    menAction[id].time = false;
                    let metaKey = menGetFormKeyMeta(id, key);
                    if (metaKey && metaKey["x-component"]) {
                        let xm = metaKey["x-component"];
                        // 为上传组件区别后续调用
                        if (xm === "HuoHuaUploadBox") {
                            if (value[value.length - 1]) {
                                if (value[value.length - 1].status === "done") {
                                    menOnChangeBox && menOnChangeBox(id, key, prevValue, value, Form, Field);
                                    menAction[id].setData(Form.values);
                                }
                            } else {
                                menOnChangeBox && menOnChangeBox(id, key, prevValue, value, Form, Field);
                                menAction[id].setData(Form.values);
                            }

                        }else if(xm==="AssociatedDocument"){
                            menOnChangeBox && menOnChangeBox(id, key, prevValue, value, Form, Field);
                            menAction[id].setData(Form.values,"instance");
                        } else {
                            menOnChangeBox && menOnChangeBox(id, key, prevValue, value, Form, Field);
                            menAction[id].setData(Form.values);
                        }

                    } else {
                        menOnChangeBox && menOnChangeBox(id, key, prevValue, value, Form, Field);
                        menAction[id].setData(Form.values);
                    }
                } else {
                    menAction[id].setData(Form.values);
                }
            }, 0))
            //   表单编辑前
            onFieldReact('*', (Field, Form) => {
                let key = Field.props.name;
                let active = Field.active;
                let value = Form.values[key] || "";
                if (Field.getState().readOnly) {
                    Field.setPattern("disabled")
                } else {
                    if (active === true) {
                        Field.setPattern("editable")
                    }
                    if (editable === false) {
                        Field.setPattern("disabled")
                    }
                }

                // 编辑前事件 -开发未完成  每次输入都去执行校验 似乎有点多余
                if (active === true && count === 0) {
                    count++
                    if (menOnbeforeChange) {
                        let falg = menOnbeforeChange(id, key, value, Form, Field);
                        if (!falg) {
                            Field.setPattern("readOnly")
                            return;
                        }
                    }

                } else {
                    // 重置计数器
                    if (count >= 1) {
                        count = 0

                    }
                }
            })
        }
    });
    // 导入 menActionComponents 该 对象里的组件由  menAddFormComponents 方法设置  默认为空对象
    const SchemaField = createSchemaField({
        components: {
            ...FormilyAntd,
            ...custom,
            Button,
            ...menActionComponents

        },

        scope: {
            ...menAction[id].getScope(),
        },


    })
    // 添加全局实例
    menGlobal.setInstance(id, "form", menAction[id].instance);
    return (
        <div
            className={editClass + " men-form-box " + con.className || ""}
            key={id}
        >
            {
            MenLoding.menCreateMenLoding("form_loding",{
                title:"请稍后..."
            })
         }
            {
                MenModal.menCreateModal(id+"_hint", {
                    state: {
                        title: ""
                    },
                    
                    initiative_close: false,
                    modalConfig: {
                        maskClosable: false
                    }
                })
            }
            <FormilyAntd.Form
                form={normalForm}
                scrollToFirstError={true}
                size="large"
                {...formConfig}

            >
                {/* <SchemaField schema={meta} /> */}
                
                <SchemaField >

                    {schemaFieldItems({ 
                        SchemaField: SchemaField, 
                        initProperties: meta.properties,
                        id,
                        meta:meta,
                        formFn:{
                            menCreateForm,
                            menSetFormData,
                            menSetFormMeta,
                            menGetFormData,
                            verifyForm,
                            menOnChangeBox
                        },
                        menAction,
                        
                         })}
                </SchemaField>
            </FormilyAntd.Form>
        </div>
    )
}

const menCreateFormCom = (props) => {
    return menCreateForm(props.id, props.con)
}

export default {
    menCreateForm,
    MenCreateFormCom: menCreateFormCom,
    menSetFormMeta,
    menGetFormInstance,
    verifyForm,
    menSetFormData,
    menSetShowHidden,
    menGetFormMeta,
    menSetShowHiddenAll,
    menGetFormData,
    menDestroy,
    menSetFormKeyMeta,
    menGetFormKeyMeta,
    menAddFormComponents
}


// const actions = createFormActions()
// const asyncActions = actions
// 创建表单 createForm
// const menCreateForm1 = (id,con={})=>{
//     if(!menAction[id]){
//         menAction[id] = {};
//     }

//     let { data = [], tableConfig = {} } = config;
//     let [dataSource, setDataSource] = useState([]);
//     let [meta, setMeta] = useState({});
//     menAction[id].setData = (res) => {
//         setDataSource([...res])
//     };
//     menAction[id].setMeta = (res) => {
//         setMeta({ ...res });
//     };
//     menAction[id].getMeta = () => {
//         return meta;
//     };
//     menAction[id].getData = () => {
//         return dataSource;
//     };
//     if(!menAction[id].refs){
//         menAction[id].refs = new Map();
//     }
//     if(!meta){
//         return null;
//     }
//     // let []
//     const components = {
//         Input,
//         Select,
//         TextArea: Input.TextArea,
//         DateRangePicker: DatePicker.RangePicker,
//     };
//     const FieldItems = createSchemaMarkupField(meta.properties||[], SchemaMarkupField, {
//         // props: props,
//         // asyncActions,
//         // dictionaries: props.dictionaries,
//       });
//     return  <div>
//         创建表单
//         <SchemaForm
//             key = {'SchemaForm--0'}
//             actions={asyncActions}
//             // value={props.formData}
//             // editable={props.editable}//是否允许编辑
//             effects={(...ars) => {
//             // $(LifeCycleTypes.ON_FIELD_VALUE_CHANGE, 'expenseType').subscribe(
//             //   fieldState => {
//             //     setFieldState('bb', state => {
//             //       state.visible = fieldState.value === 123
//             //     })
//             //   }
//             // )
//                 // useOneToManyEffects({onFieldValueChange$, createFormActions, props,
//                 //     actions:asyncActions,
//                 //     updateExpenseTypeShow,
//                 //     getModalShow,
//                 // })
//             }}
//             // labelCol={ {span: 0}}
//             // wrapperCol={16}
//             className={"huohua-x-form-SchemaForm" }
//             // expressionScope={createRichTextUtils(props)}
//             components={components}>
//             <FormCard >
//                 {FieldItems}
//             </FormCard>
//         </SchemaForm>
//     </div>
// }


