import * as util from "../../util"
// 规则 转换 方法 相应规则在此处转换成可计算的
// date_calculation 时间相加  天 
export const calculate = {
    date_calculation: function (config = {}) {
        let { i, onFieldValueChange, menAction, k, id, calculate_meth } = config;
        i.source.split(",").forEach((itk) => {
            onFieldValueChange(itk, (field) => {
                if (i.type === "date_calculation") {
                    let start = "", end = "", key = field.props.name;
                    let keySet = new Set(i.source.split(","))
                    if (("" + field.value).split("-").length > 1) {
                        start = field.value;
                        keySet.delete(key);
                        end = field.query([...keySet][0]).value() || 0;
                    } else {
                        end = field.value;
                        keySet.delete(key);
                        start = field.query([...keySet][0]).value() || 0;
                    }
                    menAction[id].instance().setFieldState(k, (state) => {
                        state.value = calculate_meth[i.type](start, end);
                    })
                }

            })
        })
    },
    // 共同选择
    together_select: function (config = {}) {
        let { i, onFieldValueChange, menAction, k, id } = config;
        i.source.split(",").forEach((itk) => {
            onFieldValueChange(itk, (field) => {
                let source_value = i.source_value;
                let arrsList = field.value.map((a, s) => {
                    return a;
                });
                // 暂时支持一个 对多个  后续可扩展
                if (typeof field.value === "object") {
                    let leftKey = "";

                    let rightKey = [];
                    for (const key in source_value) {
                        if (Object.hasOwnProperty.call(source_value, key)) {
                            const element = source_value[key];
                            leftKey = key;
                            rightKey = element
                        }
                    }
                    if (field.value.indexOf(leftKey) > -1) {
                        arrsList = field.value.concat(rightKey)
                    }
                }
                menAction[id].instance().setFieldState(k, (state) => {
                    state.value = [...new Set(arrsList)];
                })

            })
        })
    },
    // amounts_small_turn_big 数字计算 并且将计算得出的值换算成大写金额
    amounts_small_turn_big: function (config = {}) {
        let { i, onFieldValueChange, menAction, k, id, calculate_meth } = config;
        let itkValue = new Map();
        i.source.split(",").forEach((itk) => {
            onFieldValueChange(itk, (field) => {

                itkValue.set(itk, field.query(itk).value());
                menAction[id].instance().setFieldState(k, (state) => {
                    state.value = calculate_meth[i.type](itkValue);
                })

            })
        })
    },
    // 全量数据浇灌 选择某一个值以后 对全量数据进行复写 删除则清空
    set_all_data: function (config = {}) {
        let { i, onFieldValueChange, menAction, k, id, calculate_meth,MenLoding } = config;

        onFieldValueChange(k, (field) => {
            let value = field.query(k).value();
            let url = i.request_url[process.env.UMI_ENV];
            if (!value[0]) {
                menAction[id].instance().setValues({},"overwrite")
            } else {
                // 取消表单级 loding 
                MenLoding.MenLodingShow("form_loding")
                if(window.menRequest){
                    window.menRequest.post(url, {
                        data: { ...value[0].querys,sourceTableName:id }
                    }).then((res) => {
    
                        if (res.success && res.data && res.data.data) {
                            let newData = {};
                            util.absAcc(res.data.data,(dataItem)=>{
                                (typeof dataItem[1] ==="string"&&dataItem[1].indexOf(",")>-1)?newData[dataItem[0]] = dataItem[1].split(","):newData[dataItem[0]] = dataItem[1];
                            })
                            delete newData["c_effective_date"];
                            menAction[id].instance().setValues(newData);
                            menAction[id].instance().clearErrors();
                            setTimeout(()=>{
                                menAction[id].instance().validate()
                            },10)
                            MenLoding.MenLodingClose("form_loding");
                        } else {
                            console.error(res)
                            MenLoding.MenLodingClose("form_loding");
                        }
                    }, (error) => {
                        console.error(error)
                        MenLoding.MenLodingClose("form_loding");
                    })
                }else{
                  console.warn("windows 上 需要 全局变量 menRequest 作为 请求方法使用 可在挂载该方法前写入默认参数")
                }
                
            }

        })
    }
}

