// 处理 表单 模板方法
// 访问每一个表单项的方法  特意针对子表
export const absAccFormItems = function(meta,properties,callback){
    for (const key in properties) {
        if (Object.hasOwnProperty.call(properties, key)) {
            const element = properties[key];
            if(callback){
                callback(element,key)
            }
            if(element.items){
                absAccFormItems(meta,element.items.properties,callback);
            }
            if(element.properties){
                absAccFormItems(meta,element.properties,callback);
            }
            
        }
    }
}
// 挂载失去焦点事件&处理简单远程下拉参数问题
export const mountOutFocus = function(config = {}){
    let {element,xCp,inputType,menAction,id,key,menOnChange,meta,
        dataSource,fixed_calculate_rules,simpleness_telnet_select} = config
    let flag = false;
    // 动态挂载失去焦点事件  Select  
    if(element["x-component"]==="Select"&&xCp){
            if(xCp.mode==="multiple"){
                flag =true;
            }
            
           
    }
    if(inputType.has(element["x-component"])){
        flag =true;
    }
    // 固定配置 挂载失去焦点事件 
    if(flag){
        menAction[id].inputTypeKeys.add(element.key);
         
        if(xCp){
            element["x-component-props"] = Object.assign(xCp,{
                onBlur:(...ars)=>{
                    // 失去焦点事件
                    menOnChange&&menOnChange(id, 
                        element["key"], 
                        dataSource[element["key"]],
                         menAction[id].getData(id)[element["key"]], {}, {});
                       
                }
            })
        }else{
            element["x-component-props"] = {
                onBlur:(...ars)=>{
                    // 失去焦点事件

                    menOnChange&&menOnChange(id, 
                        element["key"], 
                        dataSource[element["key"]],
                         menAction[id].getData(id)[element["key"]], {}, {});
                        
                }
            }
           
        }
    }
    if(xCp&&xCp["extension"]){
        let extension = xCp["extension"];
        // 固定规则计算
        if(extension["h_calculate"]){
            fixed_calculate_rules.set(element["key"],extension["h_calculate"])
        }
        if(element["x-component"]==="Select"){
            if(extension&&extension["request_url"]){
                simpleness_telnet_select.set(element["key"],{
                    queryCondition:extension["queryCondition"]||{},
                    request_url:extension["request_url"]
                })
            }
            
        }

       
    }
}
// 挂载即时校验
export const instantCheck = function(config = {}){
    let {element,reqexCinfig,IDmenAction} = config
    if(element["x-validator"]&&Array.isArray(element["x-validator"])){
        element["x-validator"].forEach((a,b)=>{
                if(typeof a.pattern === "string"&&reqexCinfig[a.pattern]){
                    
                    if(reqexCinfig[a.pattern] instanceof Function){
                        // 小数位数 如果存在   decimal places
                        if(a.decimal_places){
                            let ts =  reqexCinfig[a.pattern](a.decimal_places||2);
                            element["x-validator"][b].pattern =ts.t;
                            element["x-validator"][b].message = ts.s;
                        }else{
                            element["x-validator"] = reqexCinfig[a.pattern].bind(null,a,element["title"],IDmenAction); 
                        }
                        
                    }else{
                        element["x-validator"][b].pattern = reqexCinfig[a.pattern];
                        
                    }
                }
                
        })
    }
} 
// 挂载远程校验   
export const remoteCalibration = function(config = {}){
    let {element,xCp,menAction,id,key,request,meta} = config;
        if(xCp&&xCp["extension"]&&xCp["extension"]["remote_calibration"]){
            let extension = xCp["extension"];
            if(element["x-validator"]){
                // 如果有校验规则存在 
                // 需要将原始校验规则 另行存储备用
                if(!menAction[id].xValidator.has(key)){
                    menAction[id].xValidator.set(key,_.cloneDeep(element["x-validator"]))
                }
                element["x-validator"]=(value)=>{
                    let str = "";
                    if(typeof meta.editable ==="boolean"&&meta.editable===false){
                        if(extension.checking_rule&&extension.checking_rul==="cell_phone"){
                                return "";
                        }
                    }
                    if(Array.isArray(menAction[id].xValidator.get(key))){
                            menAction[id].xValidator.get(key).some((i)=>{
                                // 手机号时特殊处理
                                    if(i.pattern.test&&!i.pattern.test(value)){
                                        str = i.message;
                                        return true;
                                    }
                            });
                    }
                    if(str){
                        return str;
                    }
                    return new Promise((resolve) => {
                        return request?.get(extension["remote_calibration"],{
                            params:{"calibrationParameter":value}
                          }).then((res)=>{

                                if(res.success&&res.data){
                                    if(res.data.exists){
                                        resolve(res.data.message)
                                    }else{
                                        resolve("") 
                                    }
                                }else{
                                    resolve("手机号校验失败")
                                }
                                resolve(res.message)
                          },(error)=>{
                              resolve("手机号校验失败")
                          })
                      })
                }
            }else{

            }
        }
} 
// 处理 联动逻辑变现 -- 即时联动
export const linkageAgreement = function(config = {}){
        let {element,xCp,id,key,menAction} = config;
        // 向前访问 节点有联动协议存在
        if(xCp&&xCp["extension"]&&xCp["extension"]["linkage_agreement"]){
            let linkage_agreement = xCp["extension"]["linkage_agreement"];
            if(linkage_agreement.controls_other){
                let controls_other = linkage_agreement.controls_other;
                let keys = [];
                for (const controls_other_key in controls_other) {
                    if (Object.hasOwnProperty.call(controls_other, controls_other_key)) {
                        const controls_other_element = controls_other[controls_other_key];
                        keys = keys.concat(controls_other_element)
                    }
                }
                let targetsValue = `*(${[...new Set(keys)].join(",")})`;
                let scodeKeys = element.key+"_scope";
                menAction[id].setScope(scodeKeys,($self,$target)=>{
                    let falg = false;
                    let this_controls_other = $self.props.component[1].extension.linkage_agreement.controls_other;
                    let value = $self.value;
                    let thisKey = $target.props.name;
                    if(this_controls_other[value]){
                        if(this_controls_other[value].indexOf(thisKey)>-1){
                            falg = true;   
                        }
                    }
                    return falg;
                })
                element["x-controls_other"] = controls_other;
                element["x-reactions"] = {
                    target: targetsValue,
                    fulfill: {
                        state: {
                            visible: `{{${scodeKeys}($self,$target)}}`
                        // display: '{{$self.value}}',
                        },
                    },
                }
            }
                
        }
}
function getNowFormatDate() {
    var date = new Date();
    var seperator1 = "-";
    var year = date.getFullYear();
    var month = date.getMonth() + 1;
    var strDate = date.getDate();
    if (month >= 1 && month <= 9) {
        month = "0" + month;
    }
    if (strDate >= 0 && strDate <= 9) {
        strDate = "0" + strDate;
    }
    var currentdate = year + seperator1 + month + seperator1 + strDate;
    return currentdate;
}
// 处理默认值逻辑
export const defaultValueDispose = function(config = {}){
    let {element,xCp,id,key,menAction} = config;
    // 日期是否默认当天
        if(xCp&&element["x-component"]==="DatePicker"){
                if(xCp["extension"]&&xCp["extension"]["wr_defaultValue"]==="taiyaki"){
                    element["default"] = getNowFormatDate()
                }
        }
}
// 处理tips换行操作
export const  consttipsNewline = function(config = {}){
    let {element,xCp,id,key,menAction} = config;
    // 日期是否默认当天
        if(element["x-decorator-props"]&&element["x-decorator-props"]["tooltip"]){
                if(typeof element["x-decorator-props"]["tooltip"] === "string"){
                    let str = element["x-decorator-props"]["tooltip"];
                    element["x-decorator-props"]["tooltip"] = ()=>{
                        
                        let strArrs  = str;
                        // debugger
                        return <p>{strArrs.split("<br/>").map((i,k)=>{
                                return <div key={k}>{i}</div>
                        })}</p>;
                    }
                }
        }
}

    











