//将协议转换成  SchemaField 列表方法

import * as util from '../../util/index';
import MenModal from "../../Modal/exports";
import _ from "lodash";
import { Popconfirm, Button,message } from "antd"
// 固定按钮数据 这样的按钮数据 不能被收集
let buttonConfig = {
    "type": "Boolean",
    "readOnly": true,
    "required": true,
    "name": "c_button",
    "key": "c_button",
    "x-decorator": "FormItem",
    "x-component": "CustomButton",
    "x-component-props": {
    }
};
// 处理弹出式子表编辑能力  接收 status edit 编辑态 browse 浏览态
const disposeAddModalFormMeta = (ele, id, addModalId, status,config={}) => {
    let {menAction} = config;
    let eleObj = {};
    let properties = ele.items.properties;
    let control_obj = {};
    let isReturn = false;
    // if(ele["x-component-props"]&&ele["x-component-props"]["extension"]&&ele["x-component-props"]["extension"]["being_control"]){
        
    // }
    for (const key in properties) {
        
        if (Object.hasOwnProperty.call(properties, key)&&key!="column_operation") {
            const element = _.cloneDeep(properties[key]);
            let columnState =  menAction[id].instance().getFieldState(`${ele.key}.${key}`);
            if(columnState.visible){
                util.absAcc(element.properties, (res,menBreack1) => {
                    let o = res[1];
                    let xmpe = o["x-component-props"] && o["x-component-props"]["extension"];
                    // 检查是否有联动关系  有可能存在多 控 一的情况 暂时只开发 一控一情况
                    if(xmpe["being_control"]){
                        util.absAcc(xmpe["being_control"],(xmpeb_res,menBreack2)=>{
                            let xmpeb = xmpeb_res[1];
                            // 控制待选值  await_value
                            if(xmpeb["control_mode"]==="await_value"){
                                // 获取 控制者信息
                                let being_control_meta = menAction[id].metaMap[xmpeb.key];
                                let data = menAction[id].getData()[xmpeb.key];
                                // 首先检查 控制者是否有值 会不会控制本项逻辑 如果没有值  操作终止
                                if(xmpeb["wr_null_check"]){
                                    if(!data){
                                        message.warning(`请先选择${xmpeb.sub_main_key_title}`)
                                        isReturn =true;
                                        menBreack1.go_on=false;
                                        menBreack2.go_on=false;
                                        return;
                                    }
                                    
                                }
                                //非空检验完成以后需要校验 是否有下拉 且下拉属于被控制者 此处检查是否能获取到当前被控制元素的状态
                                // 如果无法获取 那么需要手动从控制者中取得预备下拉选择范围
                                let keyState = menAction[id].instance().getFieldState(`${ele.key}.0.${res[0]}`);
                                let dataSource = [];
                                // 获取不到相应的state
                                if(!keyState){
                                    let xReactions = being_control_meta["x-reactions"];
                                    let whenValueBox = being_control_meta["x-component-props"]["extension"]["in_control"][res[0]]
                                    let {whenValue={}} = whenValueBox;
                                    let xReactionsKey = "";
                                    util.absAcc(whenValue,(whenValueItems,whenValueStop)=>{
                                        if(whenValueItems[1].indexOf(data)>-1){
                                            xReactionsKey = whenValueItems[0];
                                            whenValueStop.go_on = false;
                                        }
                                    })
    
                                    util.absAcc(xReactions,(xReactionsItems,xReactionsStop)=>{
                                        if(xReactionsItems.when==xReactionsKey&&xReactionsItems.target.indexOf(res[0])>-1){
                                            dataSource = xReactionsItems.fulfill.schema.enum;
                                            xReactionsStop.go_on=false;
                                        }
                                    })
                                }else{
                                    dataSource =  [...keyState.dataSource];
                                }
                                
                                o["enum"] = dataSource;
    
                            }
                        })
                        // 终止外层递归
                        // if(isReturn){
                            
                        // }
                    }
                    o.title = xmpe.son_title;
                    if (status === "edit") {
                        let flag = xmpe["certainly_readOnly"];
                        if (!flag) {
                            o["readOnly"] = false;
                        }
                    } else {
                        o["readOnly"] = true;
                    }
                })
                eleObj = Object.assign({}, eleObj, element.properties)
                if(isReturn){
                    break;
                }
            }
            
        }
    }
    if(isReturn){
        return { properties: eleObj, key: (id + addModalId + "_form"),isReturn };
    }
    return { properties: eleObj, key: (id + addModalId + "_form"), };
}

// void 渲染机 目前只针对子表 并且不可编辑
const schmaVoidFn = (config = {}) => {
    let { SchemaField, properties = {}, type = "", id = "", fieldProps = {} } = config;
    if (!SchemaField) {
        return null;
    }
    let itmes = [];
    // 是否需要增加Void
    for (let key in properties) {
        if (Object.hasOwnProperty.call(properties, key)) {
            let element = properties[key];
            let MyComponent = SchemaField[util.titleCase(element.type)];
            let { title = "", ...otherElem } = element
            itmes.push(<SchemaField.Void
                x-component="ArrayTable.Column"
                key={element.key + "_yesVoid"}
                name={"column" + element.name}

                x-component-props={{ title: title, ...fieldProps }}
            >
                <MyComponent
                    {...otherElem}

                    readOnly={true}
                />
            </SchemaField.Void>)
        }
    }
    return itmes;
}
// 新增弹窗渲染机 
const schmaAddModalFn = (config = {}) => {
    let { element = {}, id = "", addModalId = "", itmes = [], formFn, menAction } = config;
    // 是否需要增加Void
    itmes.push(
        MenModal.menCreateModal(addModalId, {
            menStyle:{
                maxHeight:"70vh",
                overflow:"auto"
            },
            state: {
                title: element.title,
                meta: {},
                addModalId
            },
            useEffectState: (state) => {
                if (state.meta && state.meta.properties) {
                    if (state.status === "browse") {
                        state.meta.editable = false;
                    } else {
                        state.meta.editable = true;
                    }
                    formFn.menSetFormMeta(id + addModalId + "_form", state.meta)
                }
                if (state.data) {
                    formFn.menSetFormData(id + addModalId + "_form", state.data)
                }

            },
            initiative_close: false,
            modalConfig: {
                maskClosable: false
            },
            content: (state, setState) => {
                return formFn.menCreateForm(id + addModalId + "_form", {
                    formConfig: {
                        layout: "vertical"
                    }
                })
            },
            confirmClick: async (state) => {
                let ps = await formFn.verifyForm(id + addModalId + "_form", true);
                if (!ps) {
                    return
                }
                let formData = formFn.menGetFormData(id + addModalId + "_form");
                let IdFormData = menAction[id].getData();
                
                // 设置子表数据
                let newIdFormData = { ...IdFormData };
                // 分为 修改和 新增
                // 新增
                if (state.sonIndex) {
                    newIdFormData[element.key][state.sonIndex] = formData;
                }//修改
                else {
                    if (newIdFormData[element.key]) {
                        newIdFormData[element.key] = [...newIdFormData[element.key], formData];
                    } else {
                        newIdFormData[element.key] = [formData];
                    }
                }
                
                menAction[id].setData(newIdFormData, "instance");
                menAction[id].instance().clearErrors();
                MenModal.menModalClose(addModalId)
                 // id, key, prevValue, value, Form, Field
                 formFn.menOnChangeBox(id,element.key,menAction[id].hisData[element.key],newIdFormData[element.key],null,null);
                 menAction[id].hisData = {...newIdFormData};
                }
        }))
    return itmes;
}
// 按钮配置渲染机
const schmaButtconfigFn = (config = {}) => {
    let { SchemaField, element = {}, button_config = {}, id = "", addModalId, itmes = [],menAction } = config;
    if (!SchemaField) {
        return null;
    }
    itmes.push(
        <SchemaField.String
            key={element.key + "butt"}
            name={element.name}
            {...buttonConfig}
            x-component-props={
                {
                    button_config: button_config,
                    menClick: () => {
                        let virMeta = disposeAddModalFormMeta(element, id, addModalId, "edit",{menAction});
                        if(virMeta.isReturn){
                            return;
                        }
                        MenModal.menModalShow(addModalId, {
                            meta: virMeta
                        })
                    }
                }
            }
        >
        </SchemaField.String>)
    return itmes;
}
// 子表操作列
const sonFormOption = (config = {}) => {
    let {menProps,formFn,addModalId,id,element,menAction,editable} = config;
    if(element.readOnly){
        editable = false;
    }
    return <div>
        {editable?<>
            <a style={{ marginRight: 10 }} onClick={() => {
            let sonIndexString = menProps.Field.getState().address.split(".");
            let sonIndex = sonIndexString[1];
            let formData = menProps.Form.getValuesIn(sonIndexString[0] + "." + sonIndex);

            // 设置子表数据
            let virMeta = disposeAddModalFormMeta(element, id, addModalId, "edit",{menAction});
            if(virMeta.isReturn){
                return;
            }
            MenModal.menModalShow(addModalId, {
                meta: virMeta,
                data: formData,
                sonIndex
            })

        }}>修改</a>
        <Popconfirm

            title="确认删除么"
            onConfirm={() => {
                let sonIndexString = menProps.Field.getState().address.split(".");
                let sonIndex = sonIndexString[1];
                let prevdata = {...menAction[id].getData()}
                menProps.Form.deleteValuesIn(sonIndexString[0] + "." + sonIndex);
                let IdFormData = menAction[id].getData();
                // 设置子表数据
                let newIdFormData = { ...IdFormData };

                newIdFormData[element.key].splice(sonIndex, 1);
                // id, key, prevValue, value, Form, Field
                formFn.menOnChangeBox(id,element.key,prevdata[element.key],newIdFormData[element.key],null,null)
                menAction[id].setData(newIdFormData);
                menAction[id].hisData = {...newIdFormData}
               
            }}
            onCancel={() => {

            }}
            okText="确定"
            cancelText="取消"
        >
            <a style={{ marginRight: 10 }}>删除</a>
        </Popconfirm>
            </>:null}
        
        <a onClick={() => {
            let sonIndexString = menProps.Field.getState().address.split(".");
            let sonIndex = sonIndexString[1];
            let formData = menProps.Form.getValuesIn(sonIndexString[0] + "." + sonIndex);

            // 设置子表数据
            let virMeta = disposeAddModalFormMeta(element, id, addModalId, "edit",{menAction});
            if(virMeta.isReturn){
                return;
            }
            MenModal.menModalShow(addModalId, {
                meta: virMeta,
                data: formData,
                sonIndex,
                status: "browse",
                footer: () => {
                    return <Button onClick={() => {
                        MenModal.menModalClose(addModalId)
                    }}>关闭</Button>
                }
            })
        }}>查看</a>
    </div>
}
// 子表渲染机
const schmaSonFn = (config = {}) => {
    let { SchemaField, element = {}, type = "",
        id = "", itmes = [], formFn = {}, menAction, meta = {}, son_config = {} } = config;
    if (!SchemaField) {
        return null;
    }
    let xpm = element["x-component-props"] || {};
    let { extension = {}, ...othersXpm } = xpm;
    let { button_config = {}, ...othersExt } = extension;
    let addModalId = meta.key+element.key + "_add_modal";
    // 新增弹窗渲染否
    schmaAddModalFn(
        {
            addModalId,
            itmes,
            extension,
            element,
            id,
            formFn,
            menAction

        }
    )
    if (meta.editable) {
        if(!element.readOnly){
             // 按钮行渲染否
            schmaButtconfigFn(
                {
                    SchemaField,
                    addModalId,
                    itmes,
                    extension,
                    element,
                    id,
                    button_config,
                    menAction

                }
            )
        }
       
    }
    let son_table_width = 150;
    if(!meta.editable){
        son_table_width = 50;
    }
    // 自定义操作列
    element.items.properties=Object.assign({},element.items.properties,{
        column_operation:{
            "key":"column_operation",
            "type": "void",
             "x-component": "ArrayTable.Column",
             "x-component-props": {
                    "title": "操作",
                    width: son_table_width,
                    fixed: 'right',
             },
             "properties":{
                "son_tab_operation": {
                    "x-display": "visible",
                    "type": "string",
                    "name": "son_tab_operation",
                    "key": "son_tab_operation",
                    "x-decorator": "FormItem",
                    "x-component": "SonOperation",
                    "x-component-props": {
                        menDom: (menProps) => {
                            return sonFormOption({menProps,formFn,addModalId,id,element,menAction,editable:meta.editable})
                        }
                    }
                }
             }
            
        }
    });
    // 子表渲染
    itmes.push(<SchemaField.Array
        name={element.key}
        key={element.key}
        x-decorator="FormItem"
        x-component="ArrayTable"
        x-component-props={{
            ...othersXpm
        }}
        className ="son_table_box" 
        {...element}
    >
        <SchemaField.Object   type = "object" >
            {/* {schmaFn(
                { ...son_config, initProperties: element.items.properties }
            )} */}
            {/* {
                meta.editable ?
                    schmaVoidFn({
                        SchemaField: SchemaField,
                        fieldProps: {
                            fixed: 'right',
                            width: 150,
                            align: 'center',

                        },
                        properties: {
                            "son_tab_operation": {
                                "title": "操作",
                                "x-display": "visible",
                                "type": "string",
                                "name": "son_tab_operation",
                                "key": "son_tab_operation",
                                "x-decorator": "FormItem",
                                "x-component": "SonOperation",
                                "x-component-props": {
                                    menDom: (menProps) => {
                                        return sonFormOption({menProps,formFn,addModalId,id,element,menAction})
                                    }
                                }
                            }
                        },
                        id
                    }) : null
            } */}

        </SchemaField.Object>
    </SchemaField.Array>)
    return itmes;
}
// 总表渲染机
const schmaFn = (config = {}) => {
    let { SchemaField, initProperties = {}, type = "", id = "", formFn, menAction, meta = {} } = config;
    if (!SchemaField) {
        return null;
    }
    let itmes = [];
    // 是否需要增加Void
    for (let key in initProperties) {
        // if(key==="column5"){
        // }
        if (Object.hasOwnProperty.call(initProperties, key)) {
            let element = initProperties[key];
            // 此处专为子表服务 每一个子表都会经历这些
            if (element.items) {
                schmaSonFn({
                    id,
                    SchemaField,
                    element,
                    itmes,
                    formFn,
                    menAction,
                    meta,
                    son_config: config
                })
            } else {
                let MyComponent = SchemaField[util.titleCase(element.type)];
                let { properties } = element;
                itmes.push(<MyComponent
                    {...element}
                >
                    {properties ? schmaFn({ ...config, initProperties: properties }) : null}
                </MyComponent>)
            }


        }
    }

    return itmes;



}


export default schmaFn;

/*<SchemaField.Void
                                    x-component="ArrayTable.Column"
                                    name="column1"
                                    x-component-props={{ width: 50, title: 'Sort', align: 'center' }}
                                >
                                    <SchemaField.Void
                                        x-decorator="FormItem"
                                        required
                                        x-component="ArrayTable.SortHandle"
                                    />
                                </SchemaField.Void>
                                <SchemaField.Void
                                    x-component="ArrayTable.Column"
                                    name="column2"
                                    x-component-props={{ width: 80, title: 'Index', align: 'center' }}
                                >
                                   <SchemaField.String
                                        x-decorator="FormItem"
                                        required
                                        x-component="ArrayTable.Index"
                                    />
                                </SchemaField.Void>
                                <SchemaField.Void
                                    x-component="ArrayTable.Column"
                                    name="column3"
                                    x-component-props={{
                                        title: '显隐->A2',
                                        dataIndex: 'a1',
                                        width: 100,
                                    }}
                                >
                                    <SchemaField.Boolean
                                        name="a1"
                                        x-decorator="FormItem"
                                        x-component="Switch"
                                    />
                                </SchemaField.Void>
                                <SchemaField.Void
                                    x-component="ArrayTable.Column"
                                    name="column4"
                                    x-component-props={{ title: 'A2', width: 200 }}
                                >
                                    <SchemaField.String
                                        x-decorator="FormItem"
                                        name="a2"
                                        required
                                        x-component="Input"
                                    />
                                </SchemaField.Void>
                                <SchemaField.Void
                                    x-component="ArrayTable.Column"
                                    name="column5"
                                    x-component-props={{ title: 'A23', width: 200 }}
                                >
                                    <SchemaField.String
                                        x-decorator="FormItem"
                                        name="a3"
                                        required
                                        x-component="Input"
                                    />
                                </SchemaField.Void>
                                <SchemaField.Void
                                    x-component="ArrayTable.Column"
                                    name="column6"
                                    x-component-props={{
                                        title: 'Operations',
                                        dataIndex: 'operations',
                                        width: 200,
                                        fixed: 'right',
                                    }}
                                >
                                    <SchemaField.Void x-component="FormItem">
                                        <SchemaField.Void x-component="ArrayTable.Remove" />
                                        <SchemaField.Void x-component="ArrayTable.MoveDown" />
                                        <SchemaField.Void x-component="ArrayTable.MoveUp" />
                                    </SchemaField.Void>
                                </SchemaField.Void>
                                */